// SPACE HARRIER(PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{

	char fname[11];
	int i,d;
	int musnum=0;

	struct fpos md[] =
	{
		{ 0x14, 0x01, 0x1800 },	// MAIN THEME
		{ 0x15, 0x09, 0x0c00 },	// SQUILLA
		{ 0x16, 0x05, 0x0800 },	// IDA
		{ 0x16, 0x0d, 0x0700 },	// GODARNI
		{ 0x17, 0x04, 0x0600 },	// WI WI JUMBO
		{ 0x17, 0x0a, 0x0c00 },	// BATTLE FIELD
		{ 0x18, 0x06, 0x0800 },	// SYURA
		{ 0x18, 0x0e, 0x0600 },	// VALDA
		{ 0x19, 0x04, 0x0500 },	// STANRAY
		{ 0x19, 0x09, 0x0800 },	// LAKE SIDE MEMORY
		{ 0x1a, 0x01, 0x0800 },	// WINNER'S SONG
		{ 0x00, 0x00, 0x0000 },	// 
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: shcut [d88file]\n");
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x10);

	// hCo
	fcut("DRIVER", 0x01, 0x00, 0x01, 0x01, 0x01, 0x0000, 0x1000);
	fcut("PROG",   0x02, 0x01, 0x00, 0x01, 0x01, 0x0000, 0x3f00);
	fcut("PCMDAT", 0x0d, 0x06, 0x01, 0x01, 0x01, 0x0000, 0x4400);

	for (i=0; md[i].trk; i++)
	{
		sprintf(fname,"MUS%02d",musnum++);
		fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
	}

	return 0;
}
